'''
Created on 18.04.2020

@author: korolkov
'''

from escape.core.optimizer import optimizer_obj
from escape.core.common import iterate_parameters

from sys import float_info

def find_minimum(opt: optimizer_obj, numrepeat: int=100):
    min_cost = float_info.max
    parameters = []
    for _ in range(numrepeat):
        opt()
        cost = opt.best_cost
        if cost<min_cost:
            print("Found new best cost: {0:.4g}".format(cost))
            min_cost = cost
            parameters = [
                [par.name, par.get_unscaled_value(), par.error]
                    for par in iterate_parameters(opt)]
        opt.shake()
    return min_cost, parameters