import unittest
import numpy as np

from escape.core.objects import *


class TestKernelMethods(unittest.TestCase):
     
    def test_kernel(self):
        x = var("x")
        
        f = func("functor_1d", x, 10)
        k = kernel("", f, True)
         
        x = np.linspace(0, 100, 1000, dtype=float)
        y = np.zeros(shape=x.shape, dtype=float)
         
        k(x, y)
         
        for i in range(len(x)):
            self.assertAlmostEqual(y[i], 10.0)


if __name__ == '__main__':
    unittest.main()
