import unittest
import numpy as np

from escape.core import *


class TestModelMethods(unittest.TestCase):
    
    def test_functor_model(self):
        x = var("x")

        a = par("A", 1.0);
        b = par("B", 0.1);
        fac = x * a + b

        kern = kernel("evaluator", fac, True)

        absc = np.linspace(0.0, 1.0, 100, dtype=float)
        ordin = absc * a.value + b.value

        dobj = data("test_data", absc, ordin)

        mdl = np.zeros(shape=absc.shape, dtype=float)

        kern(absc, mdl)

        mdlobj = model("test_model", kern, dobj, 'none', 'none');

        mdlobj()

        simul = mdlobj.simulation
        
        for i in range(len(absc)):
            self.assertAlmostEqual(ordin[i], mdl[i])


if __name__ == '__main__':
    unittest.main()
